﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Class Window1

    Private mKontakte As New ObservableCollection(Of Kontakt)

    Private mFilter As New KontaktFilter
    Private mSortierung As New KontaktSortierer
    Private mGruppierungAktiviert As Boolean = False
    Private mGruppierung As KontaktEigenschaft = KontaktEigenschaft.Typ


    Public Property Kontakte() As ObservableCollection(Of Kontakt)
        Get
            Return mKontakte
        End Get
        Set(ByVal value As ObservableCollection(Of Kontakt))
            mKontakte = value
        End Set
    End Property
    Public ReadOnly Property Filter() As KontaktFilter
        Get
            Return mFilter
        End Get
    End Property
    Public ReadOnly Property Sortierung() As KontaktSortierer
        Get
            Return mSortierung
        End Get
    End Property
    Public Property GruppierungAktiviert() As Boolean
        Get
            Return mGruppierungAktiviert
        End Get
        Set(ByVal value As Boolean)
            mGruppierungAktiviert = value
        End Set
    End Property
    Public Property Gruppierung() As KontaktEigenschaft
        Get
            Return mGruppierung
        End Get
        Set(ByVal value As KontaktEigenschaft)
            mGruppierung = value
        End Set
    End Property


    Public Sub New()
        InitializeComponent()

        txtNurJuengerAls.DataContext = Me
        txtSuchwort.DataContext = Me
        cmbTyp.ItemsSource = New KontaktTyp() {KontaktTyp.Geschäftlich, _
                                               KontaktTyp.Privat, _
                                               KontaktTyp.Sonstige}
        cmbTyp.DataContext = Me
        chkFilterTypen.DataContext = Me

        cmbSortiertNach.ItemsSource = New KontaktEigenschaft() {KontaktEigenschaft.Name, KontaktEigenschaft.Vorname, KontaktEigenschaft.Typ, KontaktEigenschaft.Geburtsdatum}

        cmbSortiertNach.DataContext = Me
        cmbSortierRichtung.ItemsSource = New ListSortDirection() {ListSortDirection.Ascending, ListSortDirection.Descending}
        cmbSortierRichtung.DataContext = Me

        chkGrpAktiviert.DataContext = Me
        cmbGruppierung.ItemsSource = New KontaktEigenschaft() {KontaktEigenschaft.Typ, KontaktEigenschaft.Geburtsdatum}
        cmbGruppierung.DataContext = Me

        ListView1.DataContext = Me

        Dim view As ListCollectionView = CType(CollectionViewSource.GetDefaultView(mKontakte), ListCollectionView)
        view.Filter = New Predicate(Of Object)(AddressOf mFilter.Filter)
        view.CustomSort = mSortierung

        ' Beispiel Liste
        mKontakte.Add(New Kontakt("Bernd", "Schuster", #1/8/1960#, KontaktTyp.Geschäftlich))
        mKontakte.Add(New Kontakt("Lisa", "Müller", #1/1/1965#, KontaktTyp.Privat))
        mKontakte.Add(New Kontakt("Stefan", "Meyer", #1/2/1970#, KontaktTyp.Sonstige))
        mKontakte.Add(New Kontakt("Klaus", "Schulz", #1/3/1975#, KontaktTyp.Geschäftlich))
        mKontakte.Add(New Kontakt("Martin", "Schmidt", #1/4/1980#, KontaktTyp.Sonstige))
        mKontakte.Add(New Kontakt("Christina", "Fischer", #1/5/1985#, KontaktTyp.Geschäftlich))
        mKontakte.Add(New Kontakt("Kurt", "Wagner", #1/6/1990#, KontaktTyp.Privat))
        mKontakte.Add(New Kontakt("Anne", "Bauer", #1/7/1995#, KontaktTyp.Sonstige))
        mKontakte.Add(New Kontakt("Kai", "Krüger", #1/8/2000#, KontaktTyp.Privat))
    End Sub


    Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles btnUpdate.Click
        Dim view As ListCollectionView = CType(CollectionViewSource.GetDefaultView(mKontakte), ListCollectionView)
        view.GroupDescriptions.Clear()

        If mGruppierungAktiviert Then
            If mGruppierung = KontaktEigenschaft.Typ Then
                view.GroupDescriptions.Add(New PropertyGroupDescription("Typ"))
            ElseIf mGruppierung = KontaktEigenschaft.Geburtsdatum Then
                view.GroupDescriptions.Add(New  _
                PropertyGroupDescription("Geburtsdatum", New GeburtsdekadenGruppierer))
            End If
        End If

        view.Refresh()
    End Sub


End Class
